﻿@publishTestResults @bypass-integration
Feature: Publish Reqnroll MsTest TRX Test Results

Scenario: Publish a Reqnroll MsTest TRX Scenario test result
	Given there is a remote server project prepared for publishing test results
	And there is an existing synchronized feature file
		"""
		Feature: Sample feature

		@tc:[id-of-test-case]
		Scenario: Sample scenario
			When I do something
		"""
	And there is a TRX test result file as
		"""
		<?xml version="1.0" encoding="utf-8"?>
		<TestRun id="19f99a93-fccc-4154-9ad8-fb61cf08c282" name="gaspar@SPECSOL-D02 2025-01-07 14:12:58" runUser="SPECSOL-D02\gaspar" xmlns="http://microsoft.com/schemas/VisualStudio/TeamTest/2010">
		  <Results>
			<UnitTestResult executionId="c2cf1f2c-4d34-4f20-97ae-12c04884d847" testId="38eaa076-8256-7610-1ce9-2a49bef43392" testName="SampleScenario" computerName="SPECSOL-D02" duration="00:00:00.0019023" startTime="2025-01-07T14:12:58.6266995+01:00" endTime="2025-01-07T14:12:58.6288648+01:00" testType="13cdc9d9-ddb5-4fa4-a97d-d965ccfc6d4b" outcome="Passed" testListId="8c84fa94-04c1-424b-9868-57a2d4851a1d" relativeResultsDirectory="c2cf1f2c-4d34-4f20-97ae-12c04884d847">
			  <Output>
				<StdOut>When I do something&#xD;
		-&gt; done: SampleFeatureStepDefinitions.WhenIDoSomething() (0.0s)&#xD;
		&#xD;
		&#xD;
		&#xD;
		TestContext Messages:&#xD;
		When I do something&#xD;
		-&gt; done: SampleFeatureStepDefinitions.WhenIDoSomething() (0.0s)</StdOut>
			  </Output>
			</UnitTestResult>
		  </Results>
		  <TestDefinitions>
			<UnitTest name="SampleScenario" storage="w:\specsync\samples\specsync-basic-calculator-reqnroll\mycalculator.specs\bin\debug\net6.0\mycalculator.specs.dll" id="38eaa076-8256-7610-1ce9-2a49bef43392">
			  <Execution id="c2cf1f2c-4d34-4f20-97ae-12c04884d847" />
			  <TestMethod codeBase="W:\SpecSync\Samples\specsync-basic-calculator-reqnroll\MyCalculator.Specs\bin\Debug\net6.0\MyCalculator.Specs.dll" adapterTypeName="executor://mstestadapter/v2" className="MyCalculator.Specs.Features.SampleFeatureFeature" name="SampleScenario" />
			</UnitTest>
		  </TestDefinitions>
		</TestRun>
		"""
	When the test result is published
	Then the command should not fail
	And the there should be a Test Run registered with test results
		| test case ID      | outcome |
		| [id-of-test-case] | Passed  |

Scenario: Publish a Reqnroll MsTest TRX Scenario Outline test result
	Given there is a remote server project prepared for publishing test results
	And there is an existing synchronized feature file
		"""
		Feature: Sample feature

		@tc:[id-of-test-case]
		Scenario Outline: Sample scenario outline
			When I do <what>
			Then the scenario <result>
		Examples:
			| what           | result |
			| something      | passes |
			| something else | fails  |
		"""
	And there is a TRX test result file as
		"""
		<?xml version="1.0" encoding="utf-8"?>
		<TestRun id="19f99a93-fccc-4154-9ad8-fb61cf08c282" name="gaspar@SPECSOL-D02 2025-01-07 14:12:58" runUser="SPECSOL-D02\gaspar" xmlns="http://microsoft.com/schemas/VisualStudio/TeamTest/2010">
		  <Results>
			<UnitTestResult executionId="040dd53f-06ca-4f4e-b1a8-4f1df21bc91f" testId="65aa5582-4cab-cbcb-d759-b8044b642b1d" testName="SampleScenarioOutline (&quot;something&quot;,&quot;passes&quot;,null)" computerName="SPECSOL-D02" duration="00:00:00.0013818" startTime="2025-01-07T15:10:48.9750469+01:00" endTime="2025-01-07T15:10:48.9765719+01:00" testType="13cdc9d9-ddb5-4fa4-a97d-d965ccfc6d4b" outcome="Passed" testListId="8c84fa94-04c1-424b-9868-57a2d4851a1d" relativeResultsDirectory="040dd53f-06ca-4f4e-b1a8-4f1df21bc91f">
			  <Output>
				<StdOut>When I do something&#xD;
		-&gt; done: SampleFeature1StepDefinitions.WhenIDoSomething() (0.0s)&#xD;
		Then the scenario passes&#xD;
		-&gt; done: SampleFeature1StepDefinitions.ThenTheScenarioPasses("passes") (0.0s)&#xD;
		&#xD;
		&#xD;
		&#xD;
		TestContext Messages:&#xD;
		When I do something&#xD;
		-&gt; done: SampleFeature1StepDefinitions.WhenIDoSomething() (0.0s)&#xD;
		Then the scenario passes&#xD;
		-&gt; done: SampleFeature1StepDefinitions.ThenTheScenarioPasses("passes") (0.0s)</StdOut>
			  </Output>
			</UnitTestResult>
			<UnitTestResult executionId="3f63c02f-8bae-4306-937c-04901a340214" testId="cc19b29d-b0ae-858b-557a-d9896fb348e0" testName="SampleScenarioOutline (&quot;something else&quot;,&quot;fails&quot;,null)" computerName="SPECSOL-D02" duration="00:00:00.0013425" startTime="2025-01-07T15:10:48.9766200+01:00" endTime="2025-01-07T15:10:48.9780516+01:00" testType="13cdc9d9-ddb5-4fa4-a97d-d965ccfc6d4b" outcome="Failed" testListId="8c84fa94-04c1-424b-9868-57a2d4851a1d" relativeResultsDirectory="3f63c02f-8bae-4306-937c-04901a340214">
			  <Output>
				<StdOut>When I do something else&#xD;
		-&gt; done: SampleFeature1StepDefinitions.WhenIDoSomethingElse() (0.0s)&#xD;
		Then the scenario fails&#xD;
		-&gt; error: Assert.AreEqual failed. Expected:&lt;fails&gt;. Actual:&lt;passes&gt;.  (0.0s)&#xD;
		&#xD;
		&#xD;
		&#xD;
		TestContext Messages:&#xD;
		When I do something else&#xD;
		-&gt; done: SampleFeature1StepDefinitions.WhenIDoSomethingElse() (0.0s)&#xD;
		Then the scenario fails&#xD;
		-&gt; error: Assert.AreEqual failed. Expected:&lt;fails&gt;. Actual:&lt;passes&gt;.  (0.0s)</StdOut>
				<ErrorInfo>
				  <Message>Assert.AreEqual failed. Expected:&lt;fails&gt;. Actual:&lt;passes&gt;. </Message>
				  <StackTrace>   at MyCalculator.Specs.StepDefinitions.SampleFeature1StepDefinitions.ThenTheScenarioPasses(String result) in W:\SpecSync\Samples\specsync-basic-calculator-reqnroll\MyCalculator.Specs\StepDefinitions\SampleFeature1StepDefinitions.cs:line 23&#xD;
		--- End of stack trace from previous location ---&#xD;
		   at Reqnroll.Bindings.BindingInvoker.InvokeBindingAsync(IBinding binding, IContextManager contextManager, Object[] arguments, ITestTracer testTracer, DurationHolder durationHolder)&#xD;
		   at Reqnroll.Infrastructure.TestExecutionEngine.ExecuteStepMatchAsync(BindingMatch match, Object[] arguments, DurationHolder durationHolder)&#xD;
		   at Reqnroll.Infrastructure.TestExecutionEngine.ExecuteStepAsync(IContextManager contextManager, StepInstance stepInstance)&#xD;
		   at Reqnroll.Infrastructure.TestExecutionEngine.OnAfterLastStepAsync()&#xD;
		   at Reqnroll.TestRunner.CollectScenarioErrorsAsync()&#xD;
		   at MyCalculator.Specs.Features.SampleFeatureFeature.ScenarioCleanupAsync()&#xD;
		   at MyCalculator.Specs.Features.SampleFeatureFeature.SampleScenarioOutline(String what, String result, String[] exampleTags) in W:\SpecSync\Samples\specsync-basic-calculator-reqnroll\MyCalculator.Specs\Features\Feature1.feature:line 8&#xD;
		</StackTrace>
				</ErrorInfo>
			  </Output>
			</UnitTestResult>
		  </Results>
		  <TestDefinitions>
			<UnitTest name="SampleScenarioOutline (&quot;something&quot;,&quot;passes&quot;,null)" storage="w:\specsync\samples\specsync-basic-calculator-reqnroll\mycalculator.specs\bin\debug\net6.0\mycalculator.specs.dll" id="65aa5582-4cab-cbcb-d759-b8044b642b1d">
			  <Execution id="040dd53f-06ca-4f4e-b1a8-4f1df21bc91f" />
			  <TestMethod codeBase="W:\SpecSync\Samples\specsync-basic-calculator-reqnroll\MyCalculator.Specs\bin\Debug\net6.0\MyCalculator.Specs.dll" adapterTypeName="executor://mstestadapter/v2" className="MyCalculator.Specs.Features.SampleFeatureFeature" name="SampleScenarioOutline" />
			</UnitTest>
			<UnitTest name="SampleScenarioOutline (&quot;something else&quot;,&quot;fails&quot;,null)" storage="w:\specsync\samples\specsync-basic-calculator-reqnroll\mycalculator.specs\bin\debug\net6.0\mycalculator.specs.dll" id="cc19b29d-b0ae-858b-557a-d9896fb348e0">
			  <Execution id="3f63c02f-8bae-4306-937c-04901a340214" />
			  <TestMethod codeBase="W:\SpecSync\Samples\specsync-basic-calculator-reqnroll\MyCalculator.Specs\bin\Debug\net6.0\MyCalculator.Specs.dll" adapterTypeName="executor://mstestadapter/v2" className="MyCalculator.Specs.Features.SampleFeatureFeature" name="SampleScenarioOutline" />
			</UnitTest>
		  </TestDefinitions>
		</TestRun>
		"""
	When the test result is published
	Then the command should not fail
	And the there should be a Test Run registered with test results
		| test case ID      | outcome | iteration outcomes | iteration parameters                                                    |
		| [id-of-test-case] | Failed  | (Passed),(Failed)  | (what: something, result: passes),(what: something else, result: fails) |

Scenario: Publish a Reqnroll MsTest TRX Scenario Outline test result with RowTests disabled
	Given there is a remote server project prepared for publishing test results
	And there is an existing synchronized feature file
		"""
		Feature: Sample feature

		@tc:[id-of-test-case]
		Scenario Outline: Sample scenario outline
			When I do <what>
		Examples:
			| what           |
			| something      |
			| something else |
		"""
	And there is a TRX test result file as
		"""
		<?xml version="1.0" encoding="utf-8"?>
		<TestRun id="19f99a93-fccc-4154-9ad8-fb61cf08c282" name="gaspar@SPECSOL-D02 2025-01-07 14:12:58" runUser="SPECSOL-D02\gaspar" xmlns="http://microsoft.com/schemas/VisualStudio/TeamTest/2010">
		  <Results>
			<UnitTestResult executionId="ab6ec2f6-c68b-42b8-b11d-9c80642a1121" testId="11a707bb-871f-b061-9344-31ce9948bc83" testName="SampleScenarioOutline_Something" computerName="SPECSOL-D02" duration="00:00:00.0009988" startTime="2025-01-07T14:23:36.9373948+01:00" endTime="2025-01-07T14:23:36.9385205+01:00" testType="13cdc9d9-ddb5-4fa4-a97d-d965ccfc6d4b" outcome="Passed" testListId="8c84fa94-04c1-424b-9868-57a2d4851a1d" relativeResultsDirectory="ab6ec2f6-c68b-42b8-b11d-9c80642a1121">
			  <Output>
				<StdOut>When I do something&#xD;
		-&gt; done: SampleFeature1StepDefinitions.WhenIDoSomething() (0.0s)&#xD;
		&#xD;
		&#xD;
		&#xD;
		TestContext Messages:&#xD;
		When I do something&#xD;
		-&gt; done: SampleFeature1StepDefinitions.WhenIDoSomething() (0.0s)</StdOut>
			  </Output>
			</UnitTestResult>
			<UnitTestResult executionId="7a67ca57-0110-4cde-baa2-c97aabb71a0d" testId="3efb2183-da4c-2571-5172-742d8a9eb3e5" testName="SampleScenarioOutline_SomethingElse" computerName="SPECSOL-D02" duration="00:00:00.0006554" startTime="2025-01-07T14:23:36.9385919+01:00" endTime="2025-01-07T14:23:36.9444291+01:00" testType="13cdc9d9-ddb5-4fa4-a97d-d965ccfc6d4b" outcome="Passed" testListId="8c84fa94-04c1-424b-9868-57a2d4851a1d" relativeResultsDirectory="7a67ca57-0110-4cde-baa2-c97aabb71a0d">
			  <Output>
				<StdOut>When I do something else&#xD;
		-&gt; done: SampleFeature1StepDefinitions.WhenIDoSomethingElse() (0.0s)&#xD;
		&#xD;
		&#xD;
		&#xD;
		TestContext Messages:&#xD;
		When I do something else&#xD;
		-&gt; done: SampleFeature1StepDefinitions.WhenIDoSomethingElse() (0.0s)</StdOut>
			  </Output>
			</UnitTestResult>
		  </Results>
		  <TestDefinitions>
			<UnitTest name="SampleScenarioOutline_Something" storage="w:\specsync\samples\specsync-basic-calculator-reqnroll\mycalculator.specs\bin\debug\net6.0\mycalculator.specs.dll" id="11a707bb-871f-b061-9344-31ce9948bc83">
			  <Execution id="ab6ec2f6-c68b-42b8-b11d-9c80642a1121" />
			  <TestMethod codeBase="W:\SpecSync\Samples\specsync-basic-calculator-reqnroll\MyCalculator.Specs\bin\Debug\net6.0\MyCalculator.Specs.dll" adapterTypeName="executor://mstestadapter/v2" className="MyCalculator.Specs.Features.SampleFeatureFeature" name="SampleScenarioOutline_Something" />
			</UnitTest>
			<UnitTest name="SampleScenarioOutline_SomethingElse" storage="w:\specsync\samples\specsync-basic-calculator-reqnroll\mycalculator.specs\bin\debug\net6.0\mycalculator.specs.dll" id="3efb2183-da4c-2571-5172-742d8a9eb3e5">
			  <Execution id="7a67ca57-0110-4cde-baa2-c97aabb71a0d" />
			  <TestMethod codeBase="W:\SpecSync\Samples\specsync-basic-calculator-reqnroll\MyCalculator.Specs\bin\Debug\net6.0\MyCalculator.Specs.dll" adapterTypeName="executor://mstestadapter/v2" className="MyCalculator.Specs.Features.SampleFeatureFeature" name="SampleScenarioOutline_SomethingElse" />
			</UnitTest>
		  </TestDefinitions>
		</TestRun>
		"""
	When the test result is published
	Then the command should not fail
	And the there should be a Test Run registered with test results
		| test case ID      | outcome |
		| [id-of-test-case] | Passed  |
